# SPDX-FileCopyrightText: 2023 eclipse foundation
# SPDX-License-Identifier: EPL-2.0

include:
  - project: 'eclipsefdn/it/releng/gitlab-runner-service/gitlab-ci-templates'
    file: 'pipeline.gitlab-ci.yml'

default:
  tags:
    - origin:eclipse


stages:
  - compliance
  - build
  - test
  - deploy

variables:
  SCAN_KUBERNETES_MANIFESTS: "true" 
  SECRET_DETECTION_EXCLUDED_PATHS: "config,matrix-*.yaml"

dco:
  allow_failure: true
  
build-tanka:
  image: grafana/tanka
  stage: build
  parallel:
    matrix:
      - PROVISIONER_ENV: 
          # - "dev"
          # - "staging"
          - "prod"
  script:
    - mkdir -p ./environments/chat-matrix/$PROVISIONER_ENV/.secrets/
    - |
      cat << EOF > ./environments/chat-matrix/$PROVISIONER_ENV/.secrets/secrets.jsonnet
      { 
        _secret+:: {
          "synapse": {
            "database_password": "XXXXXXXXXXXXXXXXX",
            "form_secret": "XXXXXXXXXXXXXXXXX",
            "macaroon_secret_key": "XXXXXXXXXXXXXXXXX",
            "registration_shared_secret": "XXXXXXXXXXXXXXXXX",
            "signing": "XXXXXXXXXXXXXXXXX",
            "oidc_providers_oauth2_eclipse_secret": "XXXXXXXXXXXXXXXX",
          },
          "matrix-media-repo": {
            "database_password": "XXXXXXXXXXXXXXXXX"
          }
        }
      }
      EOF
       
    - jb install && tk show --dangerous-allow-redirect "environments/chat-matrix/$PROVISIONER_ENV" > ./matrix-$PROVISIONER_ENV.yaml
  artifacts:
    paths:
      - "./matrix-*.yaml"
    when: on_success
    expire_in: 1 week

buildkit:
  rules:
    - when: never

hadolint:
  rules:
    - when: never

container_scanning:
  rules:
    - when: never

# OTHER ANALYSIS

iac-sast:
  needs: [build-tanka]

sast:
  needs: [build-tanka]

secret_detection:
  needs: [build-tanka]


chat-service-website:
  stage: deploy
  trigger:
    project: 'eclipsefdn/it/releng/chat-service/chat-service-website'
